<div class="p-index-preview__background">
	<canvas id="background-darker"></canvas>
	<canvas id="background-dark"></canvas>
</div>

<script type="text/javascript">

window.requestAnimFrame = (function () {
	return window.requestAnimationFrame ||
		window.webkitRequestAnimationFrame ||
		window.mozRequestAnimationFrame ||
		function (callback) {
			window.setTimeout(callback, 1000 / 60);
		};
})();

(function () {
	var waves = function (canvas, color, c, m, d) {
		var ctx = canvas.getContext('2d');
		var w;
		var h;

		canvas.width = w = window.innerWidth * 1.1;
		canvas.height = h = window.innerHeight * 1;

		var osc1 = new osc();
		var osc2 = new osc();
		var osc3 = new osc();
		var horizon = h * (d || .2);
		var count = c || 150;
		var step = Math.ceil(w / count);
		var buffer = new ArrayBuffer(count * 4);
		var points = new Float32Array(buffer);

		function fill () {
			for (var i = 0; i < count; i++) {
				points[i] = mixer(osc1, osc2, osc3);
			}
		}
		fill();

		ctx.lineWidth = 20;
		ctx.strokeStyle = color;
		ctx.fillStyle = color;

		function loop () {
			var i;

			for(i = 0; i < count - 1; i++) {
				points[i] = points[i + 1];
			}
			points[count - 1] = mixer(osc1, osc2, osc3);

			ctx.clearRect(0, 0, w, h);

			ctx.beginPath();
			ctx.moveTo(-5, points[0]);

			for (i = 1; i < count; i++) {
				ctx.lineTo(i * step, points[i]);
			}

			ctx.lineTo(w, h);
			ctx.lineTo(-5, h);
			ctx.lineTo(-5, points[1]);

			ctx.stroke();
			ctx.fill();
		}

		function osc () {
			this.variation = .4;
			this.max = m || 50;
			this.speed = 0.003;

			var me = this;
			var a = 0;
			var max = getMax();

			this.getAmp = function () {
				a += this.speed;

				if (a >= 2.0) {
					a = 0;
					max = getMax();
				}

				return max * Math.sin(a * Math.PI);
			}

			function getMax () {
				return Math.random() * me.max * me.variation + me.max * (1 - me.variation);
			}

			return this;
		}

		function mixer () {
			var d = arguments.length;
			var i = d;
			var sum = 0;

			if (d < 1) return 0;

			while(i--) sum += arguments[i].getAmp();

			return sum / d + horizon;
		}


		(function animloop(){
			requestAnimFrame(animloop);
			loop();
		})();
	};

	waves(document.getElementById('background-dark'), '#2893e0', 400, 85, .25);
	waves(document.getElementById('background-darker'), '#5848dd', 200, 100, .2);
	document.querySelector('.js-index-preview').style.backgroundColor = '#ffffff';
})();

</script>
